Index: /trunk/Assembly_Library/Src/AssemblyLibrary.asm
===================================================================
--- /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 279)
+++ /trunk/Assembly_Library/Src/AssemblyLibrary.asm	(revision 280)
@@ -74,7 +74,4 @@
 	%include "SerialServer.asm"
 	%include "SerialServerScan.asm"
-	%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-		%include "SerialServerImage.asm"
-	%endif
 	%define INCLUDE_TIME_LIBRARY
 %endif		
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 279)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 280)
@@ -3,5 +3,8 @@
 
 ; Include .inc files
+		
 %define INCLUDE_MENU_DIALOGS
+%define INCLUDE_SERIAL_LIBRARY
+		
 %include "AssemblyLibrary.inc"	; Assembly Library. Must be included first!
 %include "Romvars.inc"			; XTIDE Universal BIOS variables
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 279)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Menupages/IdeControllerMenu.asm	(revision 280)
@@ -216,21 +216,21 @@
 	dw	NULL
 
-DEVICE_SERIAL_DEFAULT_CUSTOM_PORT   EQU		300h           ; can't be any of the pre-defined COM values
+SERIAL_DEFAULT_CUSTOM_PORT   EQU		300h           ; can't be any of the pre-defined COM values
 
 PackedCOMPortAddresses:				; COM1 - COMC (or COM12)
-	db      DEVICE_SERIAL_COM1 >> 2
-	db		DEVICE_SERIAL_COM2 >> 2
-	db		DEVICE_SERIAL_COM3 >> 2
-	db		DEVICE_SERIAL_COM4 >> 2
-	db		DEVICE_SERIAL_COM5 >> 2
-	db		DEVICE_SERIAL_COM6 >> 2
-	db		DEVICE_SERIAL_COM7 >> 2
-	db		DEVICE_SERIAL_COM8 >> 2
-	db		DEVICE_SERIAL_COM9 >> 2
-	db		DEVICE_SERIAL_COMA >> 2
-	db		DEVICE_SERIAL_COMB >> 2
-	db		DEVICE_SERIAL_COMC >> 2
-	db		DEVICE_SERIAL_DEFAULT_CUSTOM_PORT >> 2			; must be last entry (see reader/writer routines)
-DEVICE_SERIAL_DEFAULT_COM			EQU		'1'
+	db      SERIAL_COM1_IOADDRESS >> 2
+	db		SERIAL_COM2_IOADDRESS >> 2
+	db		SERIAL_COM3_IOADDRESS >> 2
+	db		SERIAL_COM4_IOADDRESS >> 2
+	db		SERIAL_COM5_IOADDRESS >> 2
+	db		SERIAL_COM6_IOADDRESS >> 2
+	db		SERIAL_COM7_IOADDRESS >> 2
+	db		SERIAL_COM8_IOADDRESS >> 2
+	db		SERIAL_COM9_IOADDRESS >> 2
+	db		SERIAL_COMA_IOADDRESS >> 2
+	db		SERIAL_COMB_IOADDRESS >> 2
+	db		SERIAL_COMC_IOADDRESS >> 2
+	db		SERIAL_DEFAULT_CUSTOM_PORT >> 2			; must be last entry (see reader/writer routines)
+SERIAL_DEFAULT_COM			EQU		'1'
 
 g_rgbChoiceToValueLookupForBaud:
@@ -253,5 +253,5 @@
 	dw		g_szValueCfgBaud2400
 	dw		NULL
-DEVICE_SERIAL_DEFAULT_BAUD			EQU		((115200 / 9600)	& 0xff)
+SERIAL_DEFAULT_BAUD			EQU		((115200 / 9600)	& 0xff)
 
 ; Section containing code
@@ -519,7 +519,7 @@
 		jz		.done								; if we were already serial, nothing to do
 
-		mov		byte [es:di+IDEVARS.bSerialBaud-IDEVARS.wPort],DEVICE_SERIAL_DEFAULT_BAUD
-
-		mov		al,DEVICE_SERIAL_DEFAULT_COM
+		mov		byte [es:di+IDEVARS.bSerialBaud-IDEVARS.wPort],SERIAL_DEFAULT_BAUD
+
+		mov		al,SERIAL_DEFAULT_COM
 		add		di,IDEVARS.bSerialCOMPortChar-IDEVARS.wPort
 		call	IdeControllerMenu_SerialWriteCOM
@@ -549,5 +549,5 @@
 		mov		ah,[bx]
 
-		cmp		ah,(DEVICE_SERIAL_DEFAULT_CUSTOM_PORT >> 2)
+		cmp		ah,(SERIAL_DEFAULT_CUSTOM_PORT >> 2)
 		jz		.notFound
 
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 279)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 280)
@@ -7,5 +7,5 @@
 ; Menu title
 g_szProgramTitle:
-	db	"Configuration and Flashing program for XTIDE Universal BIOS v1.2.0.",LF,CR,NULL
+	db	"Configuration and Flashing program for XTIDE Universal BIOS v2.0.0.",LF,CR,NULL
 g_szXtideUniversalBiosSignature:	db	"XTIDE120",NULL
 g_szBiosIsNotLoaded:				db	"BIOS is not loaded!",NULL