Index: trunk/Assembly_Library/Src/File/FileIO.asm
===================================================================
--- trunk/Assembly_Library/Src/File/FileIO.asm	(revision 292)
+++ trunk/Assembly_Library/Src/File/FileIO.asm	(revision 293)
@@ -36,5 +36,5 @@
 ;	Returns:
 ;		AX:		DOS error code if CF set
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -59,7 +59,7 @@
 ;		DS:SI:	Ptr to destination buffer
 ;	Returns:
-;		AX:		Number of bytes actually read if successfull (0 if at EOF before call)
+;		AX:		Number of bytes actually read if successful (0 if at EOF before call)
 ;				DOS error code if CF set
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -83,5 +83,5 @@
 ;	Returns:
 ;		AX:		DOS error code if CF set
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -106,7 +106,7 @@
 ;		DS:SI:	Ptr to source buffer
 ;	Returns:
-;		AX:		Number of bytes actually written if successfull (EOF check)
+;		AX:		Number of bytes actually written if successful (EOF check)
 ;				DOS error code if CF set
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -131,5 +131,5 @@
 ;	Returns:
 ;		AX:		DOS error code if CF set
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -200,5 +200,5 @@
 ;		DX:AX:	Signed file size (if CF cleared)
 ;		AX:		DOS error code (if CF set)
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
@@ -257,5 +257,5 @@
 ;		DX:AX:	New file position in bytes from start of file (if CF cleared)
 ;		AX:		DOS error code (if CF set)
-;		CF:		Clear if successfull
+;		CF:		Clear if successful
 ;				Set if error
 ;	Corrupts registers:
Index: trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 293)
@@ -173,5 +173,5 @@
 
 	lds		si, [bp+DIALOG.fpDialogIO]
-	eMOVZX	cx, BYTE [si+FILE_DIALOG_IO.bFileAttributes]
+	eMOVZX	cx, [si+FILE_DIALOG_IO.bFileAttributes]
 	lds		si, [si+FILE_DIALOG_IO.fpFileFilterString]
 	call	Directory_UpdateDTAForFirstMatchForDSSIwithAttributesInCX
@@ -518,5 +518,5 @@
 	xor		ax, ax
 	stosb						; Terminate with NULL
-	jmp		SHORT CloseFileDialogAfterSuccessfullSelection
+	jmp		SHORT CloseFileDialogAfterSuccessfulSelection
 
 ;--------------------------------------------------------------------
@@ -617,5 +617,5 @@
 	test	al, al		; User cancellation?
 	jnz		SHORT ReturnWithoutHandlingKeystroke
-	jmp		CloseFileDialogAfterSuccessfullSelection
+	jmp		CloseFileDialogAfterSuccessfulSelection
 
 ALIGN JUMP_ALIGN
@@ -646,8 +646,8 @@
 	test	al, FLG_FILEDIALOG_DIRECTORY
 	jz		SHORT ReturnWithoutHandlingKeystroke
-	; Fall to CloseFileDialogAfterSuccessfullSelection
-
-;--------------------------------------------------------------------
-; CloseFileDialogAfterSuccessfullSelection
+	; Fall to CloseFileDialogAfterSuccessfulSelection
+
+;--------------------------------------------------------------------
+; CloseFileDialogAfterSuccessfulSelection
 ;	Parameters:
 ;		SS:BP:	Ptr to DIALOG
@@ -658,5 +658,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-CloseFileDialogAfterSuccessfullSelection:
+CloseFileDialogAfterSuccessfulSelection:
 	lds		di, [bp+DIALOG.fpDialogIO]
 	mov		BYTE [di+FILE_DIALOG_IO.bUserCancellation], FALSE
Index: trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm	(revision 293)
@@ -85,5 +85,5 @@
 GetWordFromUser:
 	lds		si, [bp+DIALOG.fpDialogIO]
-	eMOVZX	bx, BYTE [si+WORD_DIALOG_IO.bNumericBase]
+	eMOVZX	bx, [si+WORD_DIALOG_IO.bNumericBase]
 ALIGN JUMP_ALIGN
 .GetUserInputIntilValidOrCancelled:
Index: trunk/Assembly_Library/Src/Menu/MenuBorders.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 293)
@@ -118,5 +118,5 @@
 ALIGN JUMP_ALIGN
 MenuBorders_GetNumberOfMiddleCharactersToDX:
-	eMOVZX	dx, BYTE [bp+MENUINIT.bWidth]
+	eMOVZX	dx, [bp+MENUINIT.bWidth]
 	sub		dx, BYTE MENU_HORIZONTAL_BORDER_LINES
 	ret
@@ -136,5 +136,5 @@
 RefreshTitleBorders:
 	call	DrawTopBorderLine
-	eMOVZX	cx, BYTE [bp+MENUINIT.bTitleLines]
+	eMOVZX	cx, [bp+MENUINIT.bTitleLines]
 	jmp		SHORT DrawTextBorderLinesByCXtimes
 
@@ -152,5 +152,5 @@
 RefreshInformationBorders:
 	call	DrawSeparationBorderLine
-	eMOVZX	cx, BYTE [bp+MENUINIT.bInfoLines]
+	eMOVZX	cx, [bp+MENUINIT.bInfoLines]
 	jmp		SHORT DrawTextBorderLinesByCXtimes
 
Index: trunk/Assembly_Library/Src/Menu/MenuCharOut.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuCharOut.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/MenuCharOut.asm	(revision 293)
@@ -61,5 +61,5 @@
 	mov		al, CR
 	call	DisplayCharOut_BiosTeletypeOutput
-	eMOVZX	ax, BYTE [VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCharOutParam]
+	eMOVZX	ax, [VIDEO_BDA.displayContext+DISPLAY_CONTEXT.wCharOutParam]
 	add		di, ax
 ReturnSinceNoNeedToStartLineWithControlCharacter:
Index: trunk/Assembly_Library/Src/Menu/MenuLocation.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/MenuLocation.asm	(revision 293)
@@ -114,5 +114,5 @@
 ALIGN JUMP_ALIGN
 MenuLocation_GetMaxTextLineLengthToAX:
-	eMOVZX	ax, BYTE [bp+MENUINIT.bWidth]
+	eMOVZX	ax, [bp+MENUINIT.bWidth]
 	sub		ax, BYTE MENU_HORIZONTAL_BORDER_LINES + MENU_TEXT_COLUMN_OFFSET
 	ret
Index: trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Menu/MenuScrollbars.asm	(revision 293)
@@ -245,5 +245,5 @@
 ALIGN JUMP_ALIGN
 MenuScrollbars_GetMaxVisibleItemsOnPageToCX:
-	eMOVZX	cx, BYTE [bp+MENUINIT.bHeight]
+	eMOVZX	cx, [bp+MENUINIT.bHeight]
 	sub		cl, [bp+MENUINIT.bTitleLines]
 	sub		cl, [bp+MENUINIT.bInfoLines]
Index: trunk/Assembly_Library/Src/Serial/SerialServer.asm
===================================================================
--- trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 292)
+++ trunk/Assembly_Library/Src/Serial/SerialServer.asm	(revision 293)
@@ -3,10 +3,10 @@
 
 %include "SerialServer.inc"
-		
+
 ; Section containing code
 SECTION .text
 
 ;--------------------------------------------------------------------
-; SerialServer_SendReceive:		
+; SerialServer_SendReceive:
 ;	Parameters:
 ;       DX:		Packed I/O port and baud rate
@@ -20,6 +20,6 @@
 ;		AL, BX, CX, DX
 ;--------------------------------------------------------------------
-SerialServer_SendReceive:		
-		
+SerialServer_SendReceive:
+
 		push	si
 		push	di
@@ -37,5 +37,5 @@
 		mov		al,[bp+SerialServer_Command.bSectorCount]
 		mov		ah,[bp+SerialServer_Command.bCommand]
-		
+
 ;
 ; Command byte and sector count live at the top of the stack, pop/push are used to access
@@ -44,5 +44,7 @@
 		push	ax				; working copy on the top of the stack
 
+%ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS	; DF already cleared in Int13h.asm
 		cld
+%endif
 
 ;----------------------------------------------------------------------
@@ -121,5 +123,5 @@
 		jz		.zeroSectors
 %endif
-		
+
 ;
 ; Top of the read/write loop, one iteration per sector
@@ -278,8 +280,8 @@
 %endif
 		mov		ah, al			;  for success, AL will already be zero
-		
+
 		pop		bx				;  recover "ax" (command and count) from stack
 		pop		cx				;  recover saved sector count
-		mov		ch, 0
+		xor		ch, ch
 		sub		cl, bl			; subtract off the number of sectors that remained
 
@@ -366,10 +368,5 @@
 
 .writeTimeout1:
-%ifndef USE_186
-		mov		ax,.writeByte1Ready
-		push	ax				; return address for ret at end of SC_writeTimeout2
-%else
-		push	.writeByte1Ready
-%endif
+		ePUSH_T	ax, .writeByte1Ready	; return address for ret at end of SC_writeTimeout2
 ;;; fall-through
 
@@ -381,5 +378,5 @@
 ;               One entry point fills in AH with 20h for write
 ;		DX:		Port address (OK if already incremented to UART_lineStatus)
-;       BX:		
+;       BX:
 ;       Stack:	2 words on the stack below the command/count word
 ;	Returns:
@@ -430,5 +427,5 @@
 		pop		ax
 %endif
-		
+
 .WaitAndPoll:
 %ifndef SERIALSERVER_TIMER_LOCATION
@@ -441,5 +438,5 @@
 		pop		bx
 		pop		ax
-%endif		
+%endif
 		jc		SerialServer_OutputWithParameters_ErrorAndPop4Words
 		in		al,dx
Index: trunk/Assembly_Library/Src/String/String.asm
===================================================================
--- trunk/Assembly_Library/Src/String/String.asm	(revision 292)
+++ trunk/Assembly_Library/Src/String/String.asm	(revision 293)
@@ -37,5 +37,5 @@
 ;		CX:		Number of characters processed
 ;		SI:		Updated
-;		CF:		Cleared if successfull
+;		CF:		Cleared if successful
 ;				Set if error during conversion
 ;	Corrupts registers: